"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaggedTypeBuilder = exports.Tagged = void 0;
const Guid_1 = require("./Guid");
class Tagged {
    value;
    tag;
    constructor(value, tag) {
        this.value = value;
        this.tag = tag;
    }
    get flatten() {
        return this.value;
    }
    static generate(tag) {
        return new Tagged(Guid_1.Guid.generate(), tag);
    }
    get guidString() {
        return this.value.guidString;
    }
}
exports.Tagged = Tagged;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
class TaggedTypeBuilder {
    tag;
    builder;
    constructor(tag, builder) {
        this.tag = tag;
        this.builder = builder;
    }
    build(value, logger) {
        return new Tagged(this.builder.build(value, logger), this.tag);
    }
}
exports.TaggedTypeBuilder = TaggedTypeBuilder;
